/* Direct3D Vertex Buffer Header
   Copyright 2000-2001 TransGaming Technologies Inc.   
 */

#ifndef DDRAW_D3DVERTEXBUFFER_MAIN_H_INCLUDED
#define DDRAW_D3DVERTEXBUFFER_MAIN_H_INCLUDED

typedef struct IDirect3DVertexBufferImpl IDirect3DVertexBufferImpl;

struct IDirect3DVertexBufferImpl
{
    ICOM_VFIELD_MULTI(IDirect3DVertexBuffer7);
    DWORD ref;

    DWORD flags;
    IDirect3D7Impl* owner;

    IDirect3DVertexBufferImpl* next_vb;
    IDirect3DVertexBufferImpl* prev_vb;

    void (*final_release)(IDirect3DVertexBufferImpl* This);

    HRESULT (*draw)(IDirect3DVertexBufferImpl* This,
		    IDirect3DDevice7* pD3D,
		    D3DPRIMITIVETYPE d3dptPrimitiveType,
		    DWORD dwStart, DWORD dwCount, DWORD dwFlags);
    HRESULT (*draw_indexed)(IDirect3DVertexBufferImpl* This,
			    IDirect3DDevice7* pD3D,
			    D3DPRIMITIVETYPE d3dptPrimitiveType,
			    DWORD dwStart, DWORD dwVertexCount,
			    LPWORD pwIndices, DWORD dwIndexCount,
			    DWORD dwFlags);

    BOOL locked;
    BOOL optimized;

    LPVOID vb_data;
    DWORD vb_size;
    DWORD vertex_size;

    D3DVERTEXBUFFERDESC desc;

    LPVOID private;
};

HRESULT Main_D3DVertexBuffer_Construct(IDirect3DVertexBufferImpl* This,
				       IDirect3D7* pD3D,
				       LPD3DVERTEXBUFFERDESC desc,
				       DWORD dwFlags);

HRESULT Main_D3DVertexBuffer_Create(IDirect3D7* pD3D,
				    LPD3DVERTEXBUFFERDESC desc, DWORD dwFlags,
				    IDirect3DVertexBuffer7** ppVB);

void Main_D3DVertexBuffer_final_release(IDirect3DVertexBufferImpl* This);

void Main_D3DVertexBuffer_Destroy(IDirect3DVertexBufferImpl* This);

void Main_D3DVertexBuffer_ForceDestroy(IDirect3DVertexBufferImpl* This);

ULONG WINAPI Main_D3DVertexBuffer_AddRef(IDirect3DVertexBuffer7* iface);
ULONG WINAPI Main_D3DVertexBuffer_Release(IDirect3DVertexBuffer7* iface);
HRESULT WINAPI
Main_D3DVertexBuffer_QueryInterface(IDirect3DVertexBuffer7* iface, REFIID riid,
				    LPVOID* ppObj);
HRESULT WINAPI
Main_D3DVertexBuffer_GetVertexBufferDesc(IDirect3DVertexBuffer7* iface,
					 LPD3DVERTEXBUFFERDESC pVBDesc);
HRESULT WINAPI
Main_D3DVertexBuffer_Lock(IDirect3DVertexBuffer7* iface, DWORD dwFlags,
			  LPVOID* ppData, LPDWORD pdwSize);
HRESULT WINAPI
Main_D3DVertexBuffer_Unlock(IDirect3DVertexBuffer7* iface);
HRESULT WINAPI
Main_D3DVertexBuffer_ProcessVertices(IDirect3DVertexBuffer7* iface,
				     DWORD dwVertexOp, DWORD dwDestIndex,
				     DWORD dwCount,
				     LPDIRECT3DVERTEXBUFFER7 pSrc,
				     DWORD dwSrcIndex,
				     LPDIRECT3DDEVICE7 pD3DDevice,
				     DWORD dwFlags);
HRESULT WINAPI
Main_D3DVertexBuffer_ProcessVerticesStrided(IDirect3DVertexBuffer7* iface,
					    DWORD dwVertexOp,
					    DWORD dwDestIndex, DWORD dwCount,
					    LPD3DDRAWPRIMITIVESTRIDEDDATA pStrideData,
					    DWORD dwFVF,
					    LPDIRECT3DDEVICE7 pD3DDevice,
					    DWORD dwFlags);
HRESULT WINAPI
Main_D3DVertexBuffer_Optimize(IDirect3DVertexBuffer7* iface,
			      LPDIRECT3DDEVICE7 pD3DDevice, DWORD dwFlags);
HRESULT
Main_D3DVertexBuffer_draw(IDirect3DVertexBufferImpl* This,
			  IDirect3DDevice7* pD3D,
			  D3DPRIMITIVETYPE d3dptPrimitiveType,
			  DWORD dwStart, DWORD dwCount, DWORD dwFlags);
HRESULT
Main_D3DVertexBuffer_draw_indexed(IDirect3DVertexBufferImpl* This,
				  IDirect3DDevice7* pD3D,
				  D3DPRIMITIVETYPE d3dptPrimitiveType,
				  DWORD dwStart, DWORD dwVertexCount,
				  LPWORD pwIndices, DWORD dwIndexCount,
				  DWORD dwFlags);

#endif
